Package com.io7m.coffeepick.runtime.parser.spi

# Class ParsedRuntime

java.lang.Object
com.io7m.coffeepick.runtime.parser.spi.ParsedRuntime

All Implemented Interfaces:
  `ParserResultType`, `ParserResultType.ParsedRuntimeType`

    public final class ParsedRuntime
    extends java.lang.Object
    implements ParserResultType.ParsedRuntimeType

A parsed runtime

- ## Nested Class Summary

  Nested Classes
  Modifier and Type | Class | Description
  --- | --- | ---
  `static class` | `ParsedRuntime.Builder` | Builds instances of type `ParsedRuntime`.

  ## Nested classes/interfaces inherited from interface com.io7m.coffeepick.runtime.parser.spi.ParserResultType

  `ParserResultType.Kind, ParserResultType.ParsedRepositoryType, ParserResultType.ParsedRuntimeType`

- ## Method Summary

  Modifier and Type | Method | Description
  --- | --- | ---
  `static ParsedRuntime.Builder` | `builder()` | Creates a builder for `ParsedRuntime`.
  `static ParsedRuntime` | `copyOf​(ParserResultType.ParsedRuntimeType instance)` | Creates an immutable copy of a `ParserResultType.ParsedRuntimeType` value.
  `boolean` | `equals​(java.lang.Object another)` | This instance is equal to all instances of `ParsedRuntime` that have equal attribute values.
  `int` | `hashCode()` | Computes a hash code from attributes: `runtime`.
  `static ParsedRuntime` | `of​(RuntimeDescription runtime)` | Construct a new immutable `ParsedRuntime` instance.
  `RuntimeDescription` | `runtime()` |
  `java.lang.String` | `toString()` | Prints the immutable value `ParsedRuntime` with attribute values.
  `ParsedRuntime` | `withRuntime​(RuntimeDescription value)` | Copy the current immutable object by setting a value for the `runtime` attribute.

  ### Methods inherited from class java.lang.Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

  ### Methods inherited from interface com.io7m.coffeepick.runtime.parser.spi.ParserResultType.ParsedRuntimeType

  `kind`

- ## Method Details

  - ### runtime

    public RuntimeDescription runtime()
    Specified by:
      `runtime` in interface `ParserResultType.ParsedRuntimeType`
    Returns:
      The actual runtime value

  - ### withRuntime

    public final ParsedRuntime withRuntime​(RuntimeDescription value)
    Copy the current immutable object by setting a value for the `runtime` attribute. A shallow reference equality check is used to prevent copying of the same value by returning `this`.
    Parameters:
      `value` - A new value for runtime
    Returns:
      A modified copy of the `this` object

  - ### equals

    public boolean equals​(java.lang.Object another)
    This instance is equal to all instances of `ParsedRuntime` that have equal attribute values.
    Overrides:
      `equals` in class `java.lang.Object`
    Returns:
      `true` if `this` is equal to `another` instance

  - ### hashCode

    public int hashCode()
    Computes a hash code from attributes: `runtime`.
    Overrides:
      `hashCode` in class `java.lang.Object`
    Returns:
      hashCode value

  - ### toString

    public java.lang.String toString()
    Prints the immutable value `ParsedRuntime` with attribute values.
    Overrides:
      `toString` in class `java.lang.Object`
    Returns:
      A string representation of the value

  - ### of

    public static ParsedRuntime of​(RuntimeDescription runtime)
    Construct a new immutable `ParsedRuntime` instance.
    Parameters:
      `runtime` - The value for the `runtime` attribute
    Returns:
      An immutable ParsedRuntime instance

  - ### copyOf

    public static ParsedRuntime copyOf​(ParserResultType.ParsedRuntimeType instance)
    Creates an immutable copy of a `ParserResultType.ParsedRuntimeType` value. Uses accessors to get values to initialize the new immutable instance. If an instance is already immutable, it is returned as is.
    Parameters:
      `instance` - The instance to copy
    Returns:
      A copied immutable ParsedRuntime instance

  - ### builder

    public static ParsedRuntime.Builder builder()
    Creates a builder for `ParsedRuntime`.

         ParsedRuntime.builder()
            .setRuntime(com.io7m.coffeepick.runtime.RuntimeDescription) // required runtime
            .build();

    Returns:
      A new ParsedRuntime builder